/*
 *  YASS 1.07
 *  Copyright (C) 2004,2005
 *  YASS Team
 *  Laurent Noe, Gregory Kucherov, Mikhail Roytberg, Christophe Valmir, Steven Corroy
 *  yass@loria.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software contains code derived from the GNU libavl library.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#include <stdio.h>
#include "util.h"
#include "global_var.h"
#include "tuple.h"

/********************
 * GLOBALVARIABLES  *
 ********************/


/* [1]  MODIFIED WHEN STARTING PROGRAM 
 *========================================*/


/* 1.1 parametres et flags modifis par l'utilisateur */

                                 /* +1-3    +3-2   +5-4  +3-4 */
/* ** FIXME ** : reconsider those parameters (need update) */
double      KBLASTTABLE[]    =  { 0.721 , 0.131 , 0.173 , 0.435};
double LAMBDABLASTTABLE[]    =  { 1.371 , 0.271 , 0.192 , 0.317};

int  SUBMATRIXTABLE[4][4] =
                       {  /* Match, Transversion, Transition, other */
                       {    1,        -3,         -2,          -1   },
                       {    3,        -2,         -1,          -1   },
                       {    5,        -4,         -2,          -1   },
                       {    3,        -3,         -1,          -1   }
                       };

int      INDELSTABLE[4][2] = { /* +1 -3 */
                                {8,  2},
                                /* +3 -2*/
				{12, 4},
				/* +5 -4*/
				{16, 4},
				/* +4 -3*/
				{16, 4}
                              };

int    gp_cost_gap_opened              = 0;
int    gp_cost_gap_continued           = 0;
int    gp_cost_match                   = 1;
int    gp_cost_mismatch                = -3;
int    gp_cost_transition              = -2;
int    gp_cost_other                   = -1;
int    gp_substitution_matrix[16][16];
int    gp_cost_max_substitution_matrix = 0;
double gp_k_blast                      = 0;
double gp_lambda_blast                 = 0;
int    gp_xdrop                        = 25;

/**/
int  gp_seed_bitweight            = 0;
int  gp_seed_span                 = 0;
int  gp_t                         = 1; /* t :  max repeats ratio */
char gp_motif[256]                = "#@#__##__#_##@#";  /* efficient on random regions (and selected with 3jump criterion)
                                                         "##_@#@__@_#_##@#";
                                                         "##_@_#_#@_#@@##"; 
                                                         "@#@_#__#@__@_#_@##@";*/
int  * gp_automata               = NULL ; /* increment overlap */

int    gp_minimum_score_seeds    = 13;
int    gp_minscore               =  1;
int    gp_mutations_percent      = 25;
double gp_mutations              = 0.25;
int    gp_indels_percent         = 8;
double gp_indels                 = 0.08;
int    gp_alpha_percent          = 5;
double gp_alpha                  = 0.05;

int    gp_reverse                = 0;
int    gp_display                = 0;
int    gp_nbmaxlines             = 10000;
int    gp_distdiag               = 36;
double gp_entropy_min            = 3.10;
double gp_expectation_value      = 10.00;

/* post-processing */
int    gp_win_min                = 16;
int    gp_win_max                = 256 * KILO;
int    gp_win_mul                = 16;

/* statistical variables */
int  gp_rho_stat             = 0;
int  gp_delta_stat           = 0;

/* files */
int  gp_nbfiles = 0;
char gp_files[2][256];
int  gp_selection_fasta = 1;

/* data tables */ 
char* gp_query=NULL, * gp_text=NULL;
int  gp_querysize=0,  gp_textsize=0,  gp_querysize_chunk=0;

/* [2]   MODIFIED WHEN RUNNING ...
 *================================*/

FILE * gv_outstream = NULL ;
int    gv_reverse_repeat = 0;      /* =1 when the program works
				    * on the reverse complementary strain
				    * used to memorise inversion
				    */

tuplelist * gv_last_tl =  NULL;  /* last tuple list added by "assemble"
				  * ( can be modified by  FreetupleList to
				  *   keep the last tuple list alive)
				  */
MA * gv_first_MA = NULL;

MA * gv_last_MA  = NULL;

int  gv_i_current = 0;           /* last seed considered position
				  * on the second sequence	
				  */

int  gv_left_correction = 0;     /* left correction factor
				  */


/* statistics on proccessing step */
int nb_seeds                = 0 ;
int nb_chains_built         = 0 ;
int nb_chains_tested        = 0 ;
int nb_ma                   = 0 ;

/* statistics on post processing step */
int nb_postprocessed_grouping_tests = 0;
int nb_postprocessed_grouping_links  = 0;
int nb_postprocessed_ma    = 0;

/* statistics on time spent */
int    time_spent           = 0 ;
double last_clock           = 0 ;
double clock_align          = 0 ;
double clock_chain          = 0 ;
double clock_post           = 0 ;

char lookup[16] = {'A','T','G','C','Y','S','U','N','R','M','W','D','H','V','K','B'};

#ifdef GORE_ALLOC_TUPLE
  tuple *     tupler      = NULL;
  int         i_tuple     = 0;
#endif
#ifdef GORE_ALLOC_TUPLELIST
  tuplelist * tuplelister = NULL;
  int         i_tuplelist = 0;
#endif
