/*
 *  YASS 1.07
 *  Copyright (C) 2004,2005
 *  YASS Team
 *  Laurent Noe, Gregory Kucherov, Mikhail Roytberg, Christophe Valmir, Steven Corroy
 *  yass@loria.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software contains code derived from the GNU libavl library.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef __REGROUP_H__
#define __REGROUP_H__

#define DIAG_LENGTH(map,mai)    (((mai)->right_pos_begin)-((map)->right_pos_end))
#define INDEL_LENGTH(dp,di)     (ABS((di)-(dp)))
#define DIAG_COST(x)            (((x)<0)?(-gp_cost_max_substitution_matrix *(ABS(x))):(-(ABS(x))))
#define INDEL_COST(x)           (-gp_cost_gap_opened-(((x)-1)*gp_cost_gap_continued))
#define BLAST(b1,b2,i,d)        ((b1)+(b2)+(i)+(d))
#define GOOD_LINK(b1,b2,b3)     ((b3)>(MAX((b1),(b2)))?(b3):(0))
#define INDEL_BOUND(x)          ((((x)->blastscore) / gp_cost_gap_continued) + (gp_cost_gap_opened/gp_cost_gap_continued) + 1)


#ifdef CHOOSERBTREE
#include "red_black.h"
#else
#ifdef CHOOSEAVLTREE
#include "avl.h"
#else	
#error No tree definition : uncomment either "CHOOSERBTREE" or "CHOOSEAVLTREE" in the "util.h" file
#endif
#endif


#include "list.h"

/* Element use in statistical functions */

typedef struct _elem_stat {

   float size;
   int weight;
   
}elem;



/*
* void window_deleter (int pos);
*
* Delete all the MA which are no longer in the windows at position "pos"  
*/

void window_deleter (int pos);


/*
* int regroup (MA *item);
*
* Test with blascore and distance criterions if a MA can be link with an 
* other MA and proceed if possible
*/

void regroup (list_MA *liste);


/*
* MA * main_regroup (MA *ma, int r);
*
* Proceed the global regroupement 
*/

MA * main_regroup (MA *ma, int r);


/*
* MA * main_multi_regroup (MA *ma);
*
* Proceed multi regroupement 
*/

void main_multi_regroup (MA *ma);

#endif
